from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, Boolean

Sqstoredumpmetadata_V0_1_0 = CommandToolBuilder(tool="sqStoreDumpMetaData", base_command=["sqStoreDumpMetaData"], inputs=[ToolInput(tag="in_dump_reads_from", input_type=String(optional=True), prefix="-S", doc=InputDocumentation(doc="dump reads from 'seqStore'")), ToolInput(tag="in_libs", input_type=Boolean(optional=True), prefix="-libs", doc=InputDocumentation(doc="dump information about libraries")), ToolInput(tag="in_reads", input_type=Boolean(optional=True), prefix="-reads", doc=InputDocumentation(doc="dump information about reads\nThere are four pairs of flags, one for raw, raw-trimmed,\ncorrected and corrected-trimmed.  Each pair tells if\nthe sequence is valid and if it is ignored.\n1st letter - valid (uppercase) or invalid (lowercase).\n2nd letter - used  (uppercase) or ignored (lowercase).\n1st pair   - raw sequence.\n2nd pair   - raw sequence, trimmed.\n3rd pair   - corrected sequence.\n4th pair   - corrected sequence, trimmed.\nExample:\nRR--c--- - Raw version exists and is used.  Corrected\nversion doesn't exist.\nRR--CCTt - Both raw and corrected versions exist and are used.\nCorrected trimmed version exists, but is ignored.")), ToolInput(tag="in_stats", input_type=Boolean(optional=True), prefix="-stats", doc=InputDocumentation(doc="dump summary statistics on reads")), ToolInput(tag="in_histogram", input_type=Boolean(optional=True), prefix="-histogram", doc=InputDocumentation(doc="dump a length histogram")), ToolInput(tag="in_lengths", input_type=Boolean(optional=True), prefix="-lengths", doc=InputDocumentation(doc="dump just the (sorted) read lengths")), ToolInput(tag="in_output_readslibraies_end", input_type=String(optional=True), prefix="-r", doc=InputDocumentation(doc="[-end]     output reads/libraies from `bgn` to `end`, inclusive")), ToolInput(tag="in_raw", input_type=Boolean(optional=True), prefix="-raw", doc=InputDocumentation(doc="restrict to 'raw' reads")), ToolInput(tag="in_corrected", input_type=Boolean(optional=True), prefix="-corrected", doc=InputDocumentation(doc="restrict to 'corrected' reads")), ToolInput(tag="in_trimmed", input_type=Boolean(optional=True), prefix="-trimmed", doc=InputDocumentation(doc="restrict to 'trimmed' reads")), ToolInput(tag="in_compressed", input_type=Boolean(optional=True), prefix="-compressed", doc=InputDocumentation(doc="restrict to 'compressed' reads")), ToolInput(tag="in_p", input_type=String(optional=True), position=0, doc=InputDocumentation(doc=""))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Sqstoredumpmetadata_V0_1_0().translate("wdl", allow_empty_container=True)

